/* Plugin generated by AMXX-Studio */

#include <amxmodx>
#include <amxmisc>
#include <fakemeta>
#include <hamsandwich>
#include <xs>
#include <fun>
#include <cstrike>

#define PLUGIN "Arena"
#define VERSION "1.0"
#define AUTHOR "Natsheh"

#define TASK_SHOW_OBJECTS 874654945
#define TASK_ARENA_COUNTER 876838446

new const arena_ini_file[] = "arenas.ini";
new const arena_resource_folder[] = "models/arena";

enum any:ARENA_DATA (+=1)
{
	ARENA_NAME[34] = 0,
	ARENA_RESOURCE[66],
	Float:ARENA_ORIGIN[3],
	Float:ARENA_POS_PLAYER_1[3],
	Float:ARENA_POS_PLAYER_2[3],
	Float:ARENA_POS_COUNTER[3]
}

enum (+=1)
{
	DIRECT_FORWARD = 0,
	DIRECT_BACKWARD,
	DIRECT_RIGHTWARD,
	DIRECT_LEFTWARD,
	DIRECT_UPWARD,
	DIRECT_DOWNWARD,
	DIRECTIONS_MAX
}

new const szDirections[][] = {
	"Forward",
	"Backward",
	"Rightward",
	"Leftward",
	"Upward",
	"Downward"
}

enum DUEL_PLAYER_DATA (+=1)
{
	DUEL_WEAPON = 0,
	DUEL_OPPONENT,
	DUEL_ARENA
}

new const szDuel_properties[][] = {
	"Weapon: %s",
	"Enemy: %s",
	"Arena: %s"
}

enum _:OBJECT_DATA(+= 1)
{
	OBJECT_ARENA = 0,
	OBJECT_DUELER_1,
	OBJECT_DUELER_2,
	OBJECT_ARENA_COUNTER
}

new const szObjects_Names[][] = {
	"Arena",
	"Dueler #1",
	"Dueler #2",
	"Arena Counter!"
}

enum any:SIZE (+=1)
{
	Float:MINS[3] = 0,
	Float:MAXS[3]
}

new const arena_counter_spr[][] = { "sprites/fight.spr", "sprites/num1.spr", 
					"sprites/num2.spr", "sprites/num3.spr" }
					
new user_arena[33][DUEL_PLAYER_DATA];

new Array:array_arena, Trie:trie_arena, Trie:trie_arena_size, Trie:trie_arena_modelindex, total_arenas, Float:user_fOrigins[33][OBJECT_DATA][3],
temp_data[33], user_managing_menus[33][4], temp_arena_ent[33], temp_arena_counter_ent[33];

new Float:player_size[2][3] = { { -16.0, -16.0, -36.0 }, { 16.0, 16.0, 36.0 } }

public plugin_precache()
{
	// Creating the Array, this for available arenas
	array_arena = ArrayCreate(112, 1);
	
	// Creating the Trie, this for prepared arenas
	trie_arena = TrieCreate();
	// this for retrieving the arena maxs and mins.
	trie_arena_size = TrieCreate();
	
	// this for retrieving arena model index.
	trie_arena_modelindex = TrieCreate();
	
	for(new i; i < sizeof arena_counter_spr; i++)
	{
		precache_model(arena_counter_spr[i]);
	}
	
	// Precache Arena resources...
	if(!dir_exists(arena_resource_folder))
	{
		mkdir(arena_resource_folder)
	}
	else
	{
		new sFilename[64], pos, outlen;
		while( (pos = read_dir(arena_resource_folder, pos, sFilename, charsmax(sFilename), outlen)) > 0)
		{
			if(!equali(sFilename, "arena", 5) || (contain(sFilename, ".bsp") == -1 && contain(sFilename, ".mdl") == -1)) continue;
			
			format(sFilename, charsmax(sFilename), "%s/%s", arena_resource_folder, sFilename)
			TrieSetCell(trie_arena_modelindex, sFilename, precache_model(sFilename));
		}
	}
	
	// Load Arenas...
	new sFile[96], szMapname[32];
	get_configsdir(sFile, charsmax(sFile))
	get_mapname(szMapname, charsmax(szMapname))
	format(sFile, charsmax(sFile), "%s/%s", sFile, arena_ini_file)
	new fp = fopen(sFile, "rt");
	
	if(fp > 0)
	{
		new sBuffer[168], sArenaName[34], sArenaResource[66], Float:fOrigin[3], any:xArray[ARENA_DATA], x,
		sParam[4][16], j;
		
		new szMapname[32], len, bool:Start_load;
		get_mapname(szMapname, charsmax(szMapname))
		len = strlen(szMapname);
		
		while(!feof(fp))
		{
			fgets(fp, sBuffer, charsmax(sBuffer))
			trim(sBuffer)
			
			if(sBuffer[0] == ';' || (sBuffer[1] == '/' && sBuffer[0] == '/') || strlen(sBuffer) <= 5) continue;
			
			if(sBuffer[0] == '*' || sBuffer[0] == '#' || sBuffer[0] == '@')
			{
				if(equali(szMapname, sBuffer[1], len))
				{
					Start_load = true;
					continue;
				}
				
				Start_load = false;
				continue;
			}
			
			if(!Start_load) continue;
			
			x = parse(sBuffer, sArenaName, charsmax(sArenaName), sArenaResource, charsmax(sArenaResource),
			sParam[0], charsmax(sParam[]), sParam[1], charsmax(sParam[]), sParam[2], charsmax(sParam[]),
			sParam[3], charsmax(sParam[]))
			
			remove_quotes(sArenaName)
			remove_quotes(sArenaResource)
			
			if(file_exists(sArenaResource) && x >= 2)
			{
				total_arenas++;
				
				xArray[ARENA_NAME] = sArenaName;
				xArray[ARENA_RESOURCE] = sArenaResource;
				
				if(x > 2)
				{
					x -= 2;
					
					for(j = 0; j < x; j++)
					{
						remove_quotes(sParam[j])
						StrTofVec(sParam[j], fOrigin)
						
						switch( j )
						{
							case 0: xArray[ARENA_ORIGIN] = fOrigin
							case 1: xArray[ARENA_POS_PLAYER_1] = fOrigin
							case 2: xArray[ARENA_POS_PLAYER_2] = fOrigin
							case 3: xArray[ARENA_POS_COUNTER] = fOrigin
						}
					}
					
					TrieSetCell(trie_arena, xArray[ARENA_NAME], 1)
				}
				
				ArrayPushArray(array_arena, xArray)
				
				formatex(xArray[ARENA_NAME], charsmax(xArray[ARENA_NAME]), "^0");
				formatex(xArray[ARENA_RESOURCE], charsmax(xArray[ARENA_RESOURCE]), "^0");
				xArray[ARENA_ORIGIN] = Float:{0.0,0.0,0.0};
				xArray[ARENA_POS_PLAYER_1] = Float:{0.0,0.0,0.0};
				xArray[ARENA_POS_PLAYER_2] = Float:{0.0,0.0,0.0};
				xArray[ARENA_POS_COUNTER] = Float:{0.0,0.0,0.0};
			}
		}
		fclose(fp);
	}
	else if(!file_exists(sFile))
	{
		write_file(sFile, "^n")
	}
	
	if(!total_arenas)
	{
		set_fail_state("There is no Arenas!");
		return;
	}
	
	new ent = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, "func_wall"));
	if(ent > 0)
	{
		engfunc(EngFunc_SetOrigin, ent, Float:{0.0,0.0,0.0})
		set_pev(ent, pev_solid, SOLID_BBOX)
		set_pev(ent, pev_movetype,MOVETYPE_NONE)
		
		for(new i, xArray[ARENA_DATA], any:xArray2[SIZE]; i < total_arenas; i++)
		{
			ArrayGetArray(array_arena, i, xArray)
			
			// Set Entity's model...
			engfunc(EngFunc_SetModel, ent, xArray[ARENA_RESOURCE])
			
			// load entitys data...
			dllfunc(DLLFunc_Spawn, ent)
			
			// Getting Maxs and Mins.
			pev(ent, pev_maxs, xArray2[MAXS])
			pev(ent, pev_mins, xArray2[MINS])
			
			TrieSetArray(trie_arena_size, xArray[ARENA_NAME], xArray2, sizeof xArray2)
		}
		
		// after we retrieved the maxs and mins we dont need the entity anymore....
		engfunc(EngFunc_RemoveEntity, ent)
	}
}

public plugin_end()
{
	ArrayDestroy(array_arena)
	TrieDestroy(trie_arena)
	TrieDestroy(trie_arena_size)
	TrieDestroy(trie_arena_modelindex)
}

new WEAPONS_MENU;

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	register_clcmd("say arenamanager", "clcmd_manager_arena", ADMIN_IMMUNITY)
	register_clcmd("say !duel", "clcmd_duel", ADMIN_IMMUNITY)
	
	RegisterHam(Ham_Killed, "player", "fw_player_killed_post", 1)
	
	arrayset(temp_data, -1, sizeof temp_data)
	
	WEAPONS_MENU = menu_create("Choose the weapon!?", "duel_mhandle")
	
	for(new i = CSW_P228, sWpnname[24], szInfo[4]; i <= CSW_P90; i++)
	{
		if((1<<i) & ((1<<CSW_C4)|(1<<CSW_SMOKEGRENADE)|(1<<CSW_FLASHBANG))) continue;
		get_weaponname(i, sWpnname, charsmax(sWpnname))
		if(!equal(sWpnname, "weapon_", 7)) continue;
		ucfirst(sWpnname[7])
		num_to_str(i, szInfo, charsmax(szInfo))
		menu_additem(WEAPONS_MENU, sWpnname[7], szInfo)
	}
	
	menu_setprop(WEAPONS_MENU, MPROP_EXITNAME, "Return?")
}

new bool:Is_user_inDuel[33]

public fw_player_killed_post(victim, attacker, shouldgib)
{
	if(Is_user_inDuel[victim])
	{
		new opponent = find_player("k", user_arena[victim][DUEL_OPPONENT]);
		
		set_task(2.0, "spawn_player", opponent)
		
		if(opponent == attacker)
		{
			new sWinner[32], sLoser[32];
			get_user_name(victim, sLoser, charsmax(sLoser))
			get_user_name(opponent, sWinner, charsmax(sWinner))
			client_print(0, print_chat, ".:[~Duel~]:. %s has won in a fair fight against %s!", sWinner, sLoser)
		}
		
		Duel_Ended(victim)
	}
}

public spawn_player(id)
{
	if(!is_user_connected(id)) return;
	
	ExecuteHam(Ham_CS_RoundRespawn, id);
}

Duel_Ended(id)
{
	new opponent = find_player("k", user_arena[id][DUEL_OPPONENT]);
	
	new ent, szClassname[48], xArray[ARENA_DATA];
	ArrayGetArray(array_arena, user_arena[opponent][DUEL_ARENA], xArray)
	formatex(szClassname, charsmax(szClassname), "%s_COUNTER", xArray[ARENA_NAME])
	if((ent = engfunc(EngFunc_FindEntityByString, -1, "classname", szClassname)) > 0)
	{
		engfunc(EngFunc_RemoveEntity, ent)
	}
	
	user_arena[id][DUEL_OPPONENT] = 0;
	user_arena[id][DUEL_WEAPON] = 0;
	user_arena[id][DUEL_ARENA] = -1;
	user_arena[opponent][DUEL_OPPONENT] = 0;
	user_arena[opponent][DUEL_WEAPON] = 0;
	user_arena[opponent][DUEL_ARENA] = -1;
	
	Is_user_inDuel[opponent] = false;
	Is_user_inDuel[id] = false;
}

public client_connect(id)
{
	user_arena[id][DUEL_ARENA] = -1;
}

public clcmd_duel(id)
{
	new sText[64], menu;
	formatex(sText, charsmax(sText), "Duel menu!")
	menu = menu_create(sText, "duel_mhandle");
	
	for(new i, szValue[32], iValue; i < sizeof szDuel_properties; i++)
	{
		switch( i )
		{
			case DUEL_WEAPON:
			{
				iValue = user_arena[id][DUEL_WEAPON];
				if(CSW_P90 >= iValue >= CSW_P228) {
					get_weaponname(iValue, szValue, charsmax(szValue));
					ucfirst(szValue[7]);
					format(szValue, charsmax(szValue), szValue[7]); }
				else
					szValue = "None";
				
			}
			case DUEL_OPPONENT:
			{
				iValue = find_player("k", user_arena[id][DUEL_OPPONENT]);
				if(32 >= iValue >= 1)
					get_user_name(iValue, szValue, charsmax(szValue))
				else
					szValue = "None";
			}
			case DUEL_ARENA:
			{
				new xArray[ARENA_DATA]
				iValue = user_arena[id][DUEL_ARENA];
				if(iValue == -1)
					szValue = "None";
				else {
					ArrayGetArray(array_arena, iValue, xArray)
					formatex(szValue, charsmax(szValue), xArray[ARENA_NAME])
				}
			}
		}
		
		formatex(sText, charsmax(sText), "%s", szDuel_properties[i])
		replace(sText, charsmax(sText), "%s", szValue)
		menu_additem(menu, sText)
	}
	
	formatex(sText, charsmax(sText), "Submit!")
	new opponent = find_player("k", user_arena[id][DUEL_OPPONENT]), paccess, arenaid = user_arena[id][DUEL_ARENA];
	if(!(CSW_P90 >= user_arena[id][DUEL_WEAPON] >= CSW_P228))
	{
		formatex(sText, charsmax(sText), "Submit!^n   \rThe Weapon is not valid!")
		paccess = (1<<26);
	}
	else if(Is_user_inDuel[opponent] || !is_user_connected(opponent))
	{
		formatex(sText, charsmax(sText), "Submit!^n   \rThe Opponent is not Available!")
		paccess = (1<<26);
	}
	else if(arenaid == -1)
	{
		formatex(sText, charsmax(sText), "Submit!^n   \rSelect your Arena!")
		paccess = (1<<26);
	}
	else
	{
		new players[32], pnum;
		get_players(players, pnum, "ach")
		for(new j; j < pnum; j++)
		{
			opponent = players[j];
			
			if(Is_user_inDuel[opponent] && user_arena[opponent][DUEL_ARENA] == arenaid || 
			temp_data[opponent] == arenaid)
			{
				formatex(sText, charsmax(sText), "Submit!^n   \rThe Arena is not Available!")
				paccess = (1<<26);
				break;
			}
		}
	}
	
	menu_addblank(menu, 0)
	menu_additem(menu, sText, "", paccess)
	
	menu_display(id, menu)
}

public duel_mhandle(id, menu, item)
{
	if(menu == WEAPONS_MENU)
	{
		if(item != MENU_EXIT)
		{
			new sData[4], pAccess, iCallback;
			menu_item_getinfo(menu, item, pAccess, sData, charsmax(sData), "", 0, iCallback)
			
			user_arena[id][DUEL_WEAPON] = str_to_num(sData);
		}
		
		clcmd_duel(id);
		return 1;
	}
	if(user_managing_menus[id][0] == menu) //if its a player menu...
	{
		if(item != MENU_EXIT)
		{
			new sData[32], pAccess, iCallback;
			menu_item_getinfo(menu, item, pAccess, sData, charsmax(sData), "", 0, iCallback)
			
			user_arena[id][DUEL_OPPONENT] = str_to_num(sData);
		}
		
		user_managing_menus[id][0] = 0;
		menu_destroy(menu)
		
		clcmd_duel(id)
		return 1;
	}
	if( menu == user_managing_menus[id][1] ) // if its a arenas menu...
	{
		if(item != MENU_EXIT)
		{
			new sData[4], pAccess, iCallback;
			menu_item_getinfo(menu, item, pAccess, sData, charsmax(sData), "", 0, iCallback)
			user_arena[id][DUEL_ARENA] = str_to_num(sData);
		}
		
		user_managing_menus[id][1] = 0;
		menu_destroy(menu)
		
		clcmd_duel(id)
		return 1;
	}
	switch( item )
	{
		case MENU_EXIT: return 1;
		case 0: menu_display(id, WEAPONS_MENU)
		case 1:
		{
			user_managing_menus[id][0] = menu = menu_create("Choose your opponent!", "duel_mhandle")
				
			new players[32], pnum, szName[48], szInfo[32], paccess, z;
			get_players(players, pnum, "ah")
			for(new i, player; i < pnum; i++)
			{
				player = players[i];
				if(player == id) continue;
				get_user_name(player, szName ,charsmax(szName))
				num_to_str(get_user_userid(player), szInfo, charsmax(szInfo))
				
				paccess = Is_user_inDuel[player] ? (1<<26):0;
				if(!paccess) {
					paccess = is_user_alive(player) ? 0:(1<<26);
					if(paccess) format(szName, charsmax(szName), "%s \r*DEAD*", szName); }
				else
					format(szName, charsmax(szName), "%s \r*In Duel*", szName)
				
				menu_additem(menu, szName, szInfo, paccess)
				z++;
			}
			
			if(!z)
			{
				user_managing_menus[id][0] = 0;
				client_print(id, print_chat, "There are no Available players!")
				menu_destroy(menu)
				clcmd_duel(id)
				return 1;
			}
			
			menu_setprop(menu, MPROP_EXITNAME, "Return?")
			menu_display(id, menu)
		}
		case 2:
		{
			user_managing_menus[id][1] = menu = menu_create("Choose your Arena!", "duel_mhandle")
			new players[32], pnum, szInfo[4], z;
			get_players(players, pnum, "ach")
			for(new i, j, paccess, player, sText[64], xArray[ARENA_DATA]; i < total_arenas; i++)
			{
				ArrayGetArray(array_arena, i, xArray)
				
				if(!TrieKeyExists(trie_arena, xArray[ARENA_NAME])) continue;
				
				paccess = 0;
				for(j = 0; j < pnum; j++)
				{
					player = players[j];
					if(player == id) continue;
					if((Is_user_inDuel[player] && user_arena[player][DUEL_ARENA] == i) || temp_data[player] == i)
					{
						paccess = (1<<26);
						break;
					}
				}
				
				formatex(sText, charsmax(sText), xArray[ARENA_NAME])
				if(paccess > 0) format(sText, charsmax(sText), "%s \r* Not Available *", sText)
				num_to_str(i, szInfo, charsmax(szInfo))
				menu_additem(menu, sText, szInfo, paccess)
				z++;
			}
			
			if(!z)
			{
				user_managing_menus[id][1] = 0;
				client_print(id, print_chat, "There are no Available Arenas!")
				menu_destroy(menu)
				clcmd_duel(id)
				return 1;
			}
			
			menu_setprop(menu, MPROP_EXITNAME, "Return?")
			menu_display(id, menu)
		}
		case 3..7:
		{
			new opponent = find_player("k", user_arena[id][DUEL_OPPONENT]), arenaid = user_arena[id][DUEL_ARENA];
			if(!is_user_connected(opponent) || Is_user_inDuel[opponent])
			{
				clcmd_duel(id)
				return 1;
			}
			else
			{
				new players[32], pnum;
				get_players(players, pnum, "ah")
				for(new j; j < pnum; j++)
				{
					opponent = players[j];
					if(opponent == id) continue;
					if(Is_user_inDuel[opponent] && user_arena[opponent][DUEL_ARENA] == arenaid || temp_data[opponent] == arenaid)
					{
						clcmd_duel(id)
						return 1;
					}
				}
			}
			
			opponent = find_player("k", user_arena[id][DUEL_OPPONENT])
			Is_user_inDuel[id] = true;
			Is_user_inDuel[opponent] = true;
			
			user_arena[opponent] = user_arena[id];
			user_arena[opponent][DUEL_OPPONENT] = get_user_userid(id);
			
			strip_user_weapons(id)
			strip_user_weapons(opponent)
			set_user_maxspeed(id, -1.0)
			set_user_maxspeed(opponent, -1.0)
			
			new xArray[ARENA_DATA];
			ArrayGetArray(array_arena, user_arena[id][DUEL_ARENA], xArray)
			
			engfunc(EngFunc_SetOrigin, id, xArray[ARENA_POS_PLAYER_1])
			engfunc(EngFunc_SetOrigin, opponent, xArray[ARENA_POS_PLAYER_2])
			
			new ent = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, "env_sprite"));
			if(ent > 0)
			{
				new szClassname[48];
				formatex(szClassname, charsmax(szClassname), "%s_COUNTER", xArray[ARENA_NAME])
				set_pev(ent, pev_classname, szClassname)
				
				engfunc(EngFunc_SetOrigin, ent, xArray[ARENA_POS_COUNTER]);
				set_pev(ent, pev_iuser1, id)
				set_pev(ent, pev_iuser2, opponent)
				set_pev(ent, pev_iuser3, user_arena[id][DUEL_WEAPON])
				set_pev(ent, pev_iuser4, sizeof arena_counter_spr-1)
				
				set_pev(ent, pev_rendermode, kRenderTransAdd)
				set_pev(ent, pev_rendercolor, Float:{0.0,255.0,0.0})
				set_pev(ent, pev_renderamt, 255.0)
				
				set_task(1.0, "task_arena_counter", ent + TASK_ARENA_COUNTER, _, _, "b")
			}
		}
	}
	return 1;
}

public task_arena_counter(const taskid)
{
	new ent = taskid - TASK_ARENA_COUNTER;
	
	if(!pev_valid(ent))
	{
		remove_task(taskid)
		return;
	}
	
	new Float:fColors[3]={0.0,255.0,0.0}, count;
	
	switch( (count = pev(ent, pev_iuser4)) )
	{
		case 0:
		{
			xs_vec_copy(Float:{255.0,0.0,0.0}, fColors)
			
			new wpnid = pev(ent, pev_iuser3);
			
			new sWpnname[24];
			get_weaponname(wpnid, sWpnname, charsmax(sWpnname))
			
			new dueler1 = pev(ent, pev_iuser1), dueler2 = pev(ent, pev_iuser2);
			give_item(dueler1, sWpnname)
			give_item(dueler2, sWpnname)
			
			if(wpnid != CSW_KNIFE)
			{
				cs_set_user_bpammo(dueler1, wpnid, 1000)
				cs_set_user_bpammo(dueler2, wpnid, 1000)
			}
		}
		case 1: xs_vec_copy(Float:{255.0,255.0,0.0}, fColors)
		case 2: xs_vec_copy(Float:{120.0,195.0,0.0}, fColors)
		case 3: xs_vec_copy(Float:{0.0,255.0,0.0}, fColors)
		default:
		{
			remove_task(taskid);
			engfunc(EngFunc_RemoveEntity, ent);
			
			return ;
		}
	}
	
	engfunc(EngFunc_SetModel, ent, arena_counter_spr[count])
	set_pev(ent, pev_rendercolor, fColors)
	
	count--;
	set_pev(ent, pev_iuser4, count)
}

public client_disconnect(id)
{
	remove_task(id + TASK_SHOW_OBJECTS);
	temp_data[id] = -1;
	
	new ent;
	if((ent = temp_arena_ent[id]) > 0)
	{
		engfunc(EngFunc_RemoveEntity, ent)
		temp_arena_ent[id] = 0;
	}
	if((ent = temp_arena_counter_ent[id]) > 0)
	{
		engfunc(EngFunc_RemoveEntity, ent)
		temp_arena_counter_ent[id] = 0;
	}
	
	if(Is_user_inDuel[id])
	{
		new opponent = find_player("k", user_arena[id][DUEL_OPPONENT]);
		set_task(2.0, "spawn_player", opponent)
		
		Duel_Ended(id)
	}
}

public clcmd_manager_arena(id, level, cid)
{
	if(!cmd_access(id, level, cid, 0))
	{
		return 1;
	}
	
	new item = temp_data[id] = find_available_arenas(), xArray[ARENA_DATA];
	
	if(item > -1) {
		ArrayGetArray(array_arena, item, xArray); }
	else {
		formatex(xArray[ARENA_NAME], charsmax(xArray[ARENA_NAME]), "None"); }
	
	new bool:bCreate = TrieKeyExists(trie_arena, xArray[ARENA_NAME]) ? false:true;
	
	// if its not create mod then its edit mod....
	if(!bCreate)
	{
		xs_vec_copy(xArray[ARENA_ORIGIN], user_fOrigins[id][OBJECT_ARENA])
		xs_vec_copy(xArray[ARENA_POS_PLAYER_1], user_fOrigins[id][OBJECT_DUELER_1])
		xs_vec_copy(xArray[ARENA_POS_PLAYER_2], user_fOrigins[id][OBJECT_DUELER_2])
		xs_vec_copy(xArray[ARENA_POS_COUNTER], user_fOrigins[id][OBJECT_ARENA_COUNTER])
	}
	else
	{
		xs_vec_copy(Float:{0.0,0.0,0.0}, user_fOrigins[id][OBJECT_ARENA])
		xs_vec_copy(Float:{0.0,0.0,0.0}, user_fOrigins[id][OBJECT_DUELER_1])
		xs_vec_copy(Float:{0.0,0.0,0.0}, user_fOrigins[id][OBJECT_DUELER_2])
		xs_vec_copy(Float:{0.0,0.0,0.0}, user_fOrigins[id][OBJECT_ARENA_COUNTER])
	}
	
	arena_creation_menu(id, xArray[ARENA_NAME], bCreate)
	if(!task_exists(id+TASK_SHOW_OBJECTS)) set_task(0.2, "task_show_boxes", id + TASK_SHOW_OBJECTS, _, _, "b");
	return 1;
}

arena_creation_menu(id, const arena[], bool:bCreate)
{
	new sText[64]
	
	formatex(sText, charsmax(sText), "(~= Arena =~) %s!", bCreate ? "Create":"Edit" )
	new xMenu = menu_create(sText, "arena_creation_mhandle");
	
	user_managing_menus[id][0] = xMenu;
	
	formatex(sText, charsmax(sText), "\yChosen Arena: \r%s", arena)
	menu_additem(xMenu, sText)
	
	new paccess = temp_data[id] == -1 ? (1<<26):0;
	
	formatex(sText, charsmax(sText), "\rArena \yOptions!")
	menu_additem(xMenu, sText, "", paccess)
	
	formatex(sText, charsmax(sText), "\wDueler \y#\r1 \yOptions!")
	menu_additem(xMenu, sText, "", paccess)
	
	formatex(sText, charsmax(sText), "\wDueler \y#\r2 \yOptions!")
	menu_additem(xMenu, sText, "", paccess)
	
	formatex(sText, charsmax(sText), "\wArena \rCounter \yOptions!")
	menu_additem(xMenu, sText, "", paccess)
	
	menu_addtext(xMenu, "^n^n", 0)
	
	paccess = 0;
	if(xs_vec_len(user_fOrigins[id][OBJECT_ARENA]) == 0.0 ||
		 xs_vec_len(user_fOrigins[id][OBJECT_DUELER_1]) == 0.0 ||
		  xs_vec_len(user_fOrigins[id][OBJECT_DUELER_2]) == 0.0 ||
		   xs_vec_len(user_fOrigins[id][OBJECT_ARENA_COUNTER]) == 0.0)
	{
		paccess = (1<<26);
	}
		
	formatex(sText, charsmax(sText), "\rSubmit!")
	menu_additem(xMenu, sText, "", paccess)
	
	menu_display(id, xMenu)
	return 1;
}

find_available_arenas()
{
	new players[32], pnum, chosen;
	get_players(players, pnum, "ch")
	for(new i, j; i < total_arenas; i++)
	{
		chosen = i;
		for(j = 0; j < pnum; j++)
		{
			if(temp_data[players[j]] == i)
			{
				chosen = -1;
				j = pnum;
				continue;
			}
		}
	}
	
	return chosen;
}

public arena_creation_mhandle(id, menu, item)
{
	if(item == MENU_EXIT)
	{
		temp_data[id] = -1;
		menu_destroy(menu)
		return 1;
	}
	
	switch( item )
	{
		case 0: available_arenas_menu(id)
		case 1: options_menu(id, OBJECT_ARENA)
		case 2: options_menu(id, OBJECT_DUELER_1)
		case 3: options_menu(id, OBJECT_DUELER_2)
		case 4: options_menu(id, OBJECT_ARENA_COUNTER)
		case 5:
		{
			new any:xArray[ARENA_DATA], itemid = temp_data[id], ent;
			ArrayGetArray(array_arena, itemid, xArray)
			
			if(TrieKeyExists(trie_arena, xArray[ARENA_NAME]))
			{
				ent = engfunc(EngFunc_FindEntityByString, -1, "classname", xArray[ARENA_NAME]);
				if(ent > 0)
				{
					new Float:fOrigin[3];
					pev(ent, pev_origin, fOrigin)
					
					if(!xs_vec_equal(fOrigin, user_fOrigins[id][OBJECT_ARENA]))
					{
						engfunc(EngFunc_SetOrigin, ent, user_fOrigins[id][OBJECT_ARENA])
					}
					
					xs_vec_copy(user_fOrigins[id][OBJECT_ARENA], xArray[ARENA_ORIGIN]);
					xs_vec_copy(user_fOrigins[id][OBJECT_DUELER_1], xArray[ARENA_POS_PLAYER_1]);
					xs_vec_copy(user_fOrigins[id][OBJECT_DUELER_2], xArray[ARENA_POS_PLAYER_2]);
					xs_vec_copy(user_fOrigins[id][OBJECT_ARENA_COUNTER], xArray[ARENA_POS_COUNTER]);
					
					ArraySetArray(array_arena, itemid, xArray)
					
					client_print(id, print_chat, "Arena '%s' has been successfully edited!", xArray[ARENA_NAME])
				}
				return 1;
			}
			
			TrieSetCell(trie_arena, xArray[ARENA_NAME], 1)
			client_print(0, print_chat, "Arena '%s' has been successfully created!", xArray[ARENA_NAME])
			
			ent = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, "func_wall"));
			if(ent > 0)
			{
				set_pev(ent, pev_classname,xArray[ARENA_NAME])
				engfunc(EngFunc_SetOrigin, ent, user_fOrigins[id][OBJECT_ARENA])
				engfunc(EngFunc_SetModel, ent, xArray[ARENA_RESOURCE])
				set_pev(ent, pev_solid, SOLID_BSP)
				set_pev(ent, pev_movetype, MOVETYPE_NONE)
				
				// load entitys data...
				dllfunc(DLLFunc_Spawn, ent)
				
				xs_vec_copy(user_fOrigins[id][OBJECT_ARENA], xArray[ARENA_ORIGIN]);
				xs_vec_copy(user_fOrigins[id][OBJECT_DUELER_1], xArray[ARENA_POS_PLAYER_1]);
				xs_vec_copy(user_fOrigins[id][OBJECT_DUELER_2], xArray[ARENA_POS_PLAYER_2]);
				xs_vec_copy(user_fOrigins[id][OBJECT_ARENA_COUNTER], xArray[ARENA_POS_COUNTER]);
				
				ArraySetArray(array_arena, itemid, xArray)
			}
		}
	}
	
	return 1;
}

options_menu(const id, const itemid)
{
	new sText[64]
	formatex(sText, charsmax(sText), "\r%s ^n \yChoose an Option!", szObjects_Names[itemid])
	new menu = menu_create(sText, "op_menu_handle")
	user_managing_menus[id][1] = menu;
	new Float:vlen = xs_vec_len(user_fOrigins[id][itemid]), sData[4];
	num_to_str(itemid, sData, charsmax(sData))
	
	new paccess = vlen != 0.0 ? (1<<26):0;
	menu_additem(menu, "Set Origin ?", sData, paccess)
	
	paccess = vlen == 0.0 ? (1<<26):0;
	menu_additem(menu, "Change Position!?", sData, paccess)
	menu_additem(menu, "Remove ?", sData, paccess)
	
	menu_setprop(menu, MPROP_EXITNAME, "Back.");
	menu_display(id, menu);
}

public op_menu_handle(id, menu, item)
{
	new sData[4], paccess, iCallback;
	menu_item_getinfo(menu, item, paccess, sData, charsmax(sData), "", 0, iCallback)
	menu_destroy(menu)
	
	new itemid = str_to_num(sData);
	
	switch( item )
	{
		case MENU_EXIT:
		{
			new xArray[ARENA_DATA], item = temp_data[id];
			if(item > -1) ArrayGetArray(array_arena, item, xArray)
			else formatex(xArray[ARENA_NAME], charsmax(xArray[ARENA_NAME]), "None");
			arena_creation_menu(id, xArray[ARENA_NAME], !TrieKeyExists(trie_arena, xArray[ARENA_NAME]))
		}
		case 0:
		{
			switch( itemid )
			{
				case OBJECT_ARENA:
				{
					new Float:fOrigin[3], Float:fAim[3];
					pev(id, pev_origin, fOrigin)
					pev(id, pev_view_ofs, fAim)
					xs_vec_add(fOrigin, fAim, fOrigin)
					
					pev(id, pev_v_angle, fAim)
					angle_vector(fAim, ANGLEVECTOR_FORWARD, fAim)
					xs_vec_mul_scalar(fAim, 100.0, fAim)
					xs_vec_add(fOrigin, fAim, fOrigin)
					
					new Float:fMaxs[3], Float:fMins[3];
					new any:xArray[ARENA_DATA], any:xArray2[SIZE];
					ArrayGetArray(array_arena, temp_data[id], xArray)
					TrieGetArray(trie_arena_size, xArray[ARENA_NAME], xArray2, sizeof xArray2)
					
					xs_vec_copy(xArray2[MAXS], fMaxs);
					xs_vec_copy(xArray2[MINS], fMins);
					
					is_object_stuck(fOrigin, fMaxs, fMins, fOrigin)
					
					xs_vec_copy(fOrigin, user_fOrigins[id][itemid]);
					
					client_print(id, print_chat, "Arena has been placed!")
					arena_creation_menu(id, xArray[ARENA_NAME], !TrieKeyExists(trie_arena, xArray[ARENA_NAME]))
				}
				case OBJECT_DUELER_1, OBJECT_DUELER_2, OBJECT_ARENA_COUNTER:
				{
					new any:xArray[ARENA_DATA], any:xArray2[SIZE];
					ArrayGetArray(array_arena, temp_data[id], xArray)
					
					if(xs_vec_len(user_fOrigins[id][OBJECT_ARENA]) == 0.0)
					{
						client_print(id, print_center, "Arena must be placed inorder to place the other objects!")
						arena_creation_menu(id, xArray[ARENA_NAME], !TrieKeyExists(trie_arena, xArray[ARENA_NAME]))
						return PLUGIN_HANDLED;
					}
					
					new Float:fOrigin[3], Float:fAim[3];
					pev(id, pev_origin, fOrigin)
					pev(id, pev_view_ofs, fAim)
					xs_vec_add(fOrigin, fAim, fOrigin)
					
					pev(id, pev_v_angle, fAim)
					angle_vector(fAim, ANGLEVECTOR_FORWARD, fAim)
					xs_vec_mul_scalar(fAim, 80.0, fAim)
					xs_vec_add(fOrigin, fAim, fOrigin)
					
					new Float:fMaxs[3], Float:fMins[3];
					if(itemid != OBJECT_ARENA_COUNTER) {
						xs_vec_copy(player_size[0], fMins)
						xs_vec_copy(player_size[1], fMaxs)
					}
					else {
						xs_vec_copy(Float:{10.0,10.0,10.0}, fMaxs)
						xs_vec_copy(Float:{-10.0,-10.0,-10.0}, fMins)
					}
					
					TrieGetArray(trie_arena_size, xArray[ARENA_NAME], xArray2, sizeof xArray2)
					
					xs_vec_copy(xArray2[MAXS], fMaxs);
					xs_vec_copy(xArray2[MINS], fMins);
					
					if((user_fOrigins[id][OBJECT_ARENA][0] + fMaxs[0]) >= fOrigin[0] &&
					        (user_fOrigins[id][OBJECT_ARENA][1] + fMaxs[1]) >= fOrigin[1] &&
						   (user_fOrigins[id][OBJECT_ARENA][0] + fMins[0]) <= fOrigin[0] &&
						      (user_fOrigins[id][OBJECT_ARENA][1] + fMins[1]) <= fOrigin[1])
					{
						fOrigin[2] = user_fOrigins[id][OBJECT_ARENA][2];
						user_fOrigins[id][itemid] = fOrigin;
					}
					else
					{
						client_print(id, print_chat, "Please place the object above the arena!")
					}
					
					options_menu(id, itemid)
				}
			}
		}
		case 1: control_origin_menu(id, itemid)
		case 2:
		{
			new any:xArray[ARENA_DATA], arenaid;
			ArrayGetArray(array_arena, (arenaid = temp_data[id]), xArray)
			
			xs_vec_copy(Float:{0.0,0.0,0.0}, user_fOrigins[id][itemid])
			
			if(itemid == OBJECT_ARENA)
			{
				new ent;
				if((ent = temp_arena_ent[id]) > 0)
				{
					engfunc(EngFunc_RemoveEntity, ent)
					temp_arena_ent[id] = 0;
				}
				
				xs_vec_copy(Float:{0.0,0.0,0.0}, user_fOrigins[id][OBJECT_DUELER_1])
				xs_vec_copy(Float:{0.0,0.0,0.0}, user_fOrigins[id][OBJECT_DUELER_2])
				xs_vec_copy(Float:{0.0,0.0,0.0}, user_fOrigins[id][OBJECT_ARENA_COUNTER])
			}
			
			if(itemid == OBJECT_ARENA_COUNTER || itemid == OBJECT_ARENA)
			{
				new ent;
				if((ent = temp_arena_counter_ent[id]) > 0)
				{
					engfunc(EngFunc_RemoveEntity, ent)
					temp_arena_counter_ent[id] = 0;
				}
			}
			
			if(TrieKeyExists(trie_arena, xArray[ARENA_NAME]))
			{
				TrieDeleteKey(trie_arena, xArray[ARENA_NAME])
				
				new ent = engfunc(EngFunc_FindEntityByString, -1, "classname", xArray[ARENA_NAME]);
				if(ent > 0)
				{
					engfunc(EngFunc_RemoveEntity, ent);
				}
				
				xs_vec_copy(user_fOrigins[id][OBJECT_ARENA], xArray[ARENA_ORIGIN])
				xs_vec_copy(user_fOrigins[id][OBJECT_DUELER_1], xArray[ARENA_POS_PLAYER_1])
				xs_vec_copy(user_fOrigins[id][OBJECT_DUELER_2], xArray[ARENA_POS_PLAYER_2])
				xs_vec_copy(user_fOrigins[id][OBJECT_ARENA_COUNTER], xArray[ARENA_POS_COUNTER])
				
				ArraySetArray(array_arena, arenaid, xArray)
			}
			
			options_menu(id, itemid)
		}
	}
	return PLUGIN_HANDLED;
}

available_arenas_menu(id)
{
	new m = menu_create("Select an Arena!", "arenas_menu_handle")
	user_managing_menus[id][2] = m;
	
	new players[32], pnum, j, player;
	get_players(players, pnum, "ach")
	
	for(new i, szText[64], xArray[ARENA_DATA], paccess; i < total_arenas; i++)
	{
		ArrayGetArray(array_arena, i, xArray)
		switch( TrieKeyExists(trie_arena, xArray[ARENA_NAME]) )
		{
			case true: formatex(szText, charsmax(szText), "\r%s", xArray[ARENA_NAME])
			case false: formatex(szText, charsmax(szText), "\y%s", xArray[ARENA_NAME])
		}
		
		paccess = 0;
		for(j = 0; j < pnum; j++)
		{
			player = players[j];
			
			if(Is_user_inDuel[player] && user_arena[player][DUEL_ARENA] == i)
			{
				paccess = (1<<26);
				break;
			}
		}
		
		menu_additem(m, szText, xArray[ARENA_NAME], paccess)
	}
	
	menu_setprop(m, MPROP_EXITNAME, "Back.")
	menu_display(id, m)
}

public arenas_menu_handle(id, menu, item)
{
	new sArenaName[34], paccess, iCallback;
	menu_item_getinfo(menu, item, paccess, sArenaName, charsmax(sArenaName), "", 0, iCallback)
	menu_destroy(menu)
	
	new arena = temp_data[id];
	
	new any:xArray[ARENA_DATA];
	ArrayGetArray(array_arena, arena, xArray)
	
	if(item == MENU_EXIT)
	{
		arena_creation_menu(id, xArray[ARENA_NAME], !TrieKeyExists(trie_arena, xArray[ARENA_NAME]))
		return PLUGIN_HANDLED;
	}
	
	new players[32], pnum;
	get_players(players, pnum, "ach")
	
	for(new j, player; j < pnum; j++)
	{
		player = players[j];
		
		if(Is_user_inDuel[player] && user_arena[player][DUEL_ARENA] == arena)
		{
			available_arenas_menu(id)
			return 1;
		}
	}
	
	// if its not create mod then its edit mod....
	if(TrieKeyExists(trie_arena, sArenaName))
	{
		xs_vec_copy(xArray[ARENA_ORIGIN], user_fOrigins[id][OBJECT_ARENA])
		xs_vec_copy(xArray[ARENA_POS_PLAYER_1], user_fOrigins[id][OBJECT_DUELER_1])
		xs_vec_copy(xArray[ARENA_POS_PLAYER_2], user_fOrigins[id][OBJECT_DUELER_2])
		xs_vec_copy(xArray[ARENA_POS_COUNTER], user_fOrigins[id][OBJECT_ARENA_COUNTER])
	}
	
	if((paccess = temp_arena_ent[id]) > 0 && arena != item && arena > -1)
	{
		TrieGetCell(trie_arena_modelindex, sArenaName, iCallback)
		engfunc(EngFunc_SetModel, paccess, xArray[ARENA_RESOURCE])
		//engfunc(EngFunc_ModelIndex, paccess, iCallback)
		
		engfunc(EngFunc_SetOrigin, paccess, xArray[ARENA_ORIGIN])
	}
	
	temp_data[id] = item;
	arena_creation_menu(id, sArenaName, !TrieKeyExists(trie_arena, sArenaName))
	return PLUGIN_HANDLED;
}

control_origin_menu(const id, const itemid)
{
	new sText[64];
	formatex(sText, charsmax(sText), "%s^nMove Direction?", szObjects_Names[itemid])
	new menu = menu_create(sText, "con_org_mhandle")
	user_managing_menus[id][3] = menu;
	new szInfo[4];
	num_to_str(itemid, szInfo, charsmax(szInfo))
	for(new i; i < sizeof szDirections; i++)
	{
		menu_additem(menu, szDirections[i], szInfo)
	}
	
	menu_addblank(menu, 0)
	
	num_to_str(itemid, szInfo, charsmax(szInfo))
	menu_additem(menu, "Back.", szInfo)
	
	menu_setprop(menu, MPROP_EXIT, MEXIT_NEVER);
	menu_setprop(menu, MPROP_PERPAGE, 0);
	menu_display(id, menu)
}

public con_org_mhandle(id, menu, item)
{
	new szString[4], paccess, iCallback;
	menu_item_getinfo(menu, item, paccess, szString, charsmax(szString), "", 0, iCallback)
	menu_destroy(menu)
	
	new iItemid = str_to_num(szString);
	
	if(item >= DIRECTIONS_MAX)
	{
		options_menu(id, iItemid)
		return PLUGIN_HANDLED;
	}
	
	new Float:fOrigin[3];
	fOrigin = user_fOrigins[id][iItemid];
	
	new Float:fAngle[3], Float:fDistance = 100.0;
	pev(id, pev_v_angle, fAngle)
	
	switch( item )
	{
		case DIRECT_FORWARD,DIRECT_BACKWARD:  angle_vector(fAngle, ANGLEVECTOR_FORWARD, fAngle);
		case DIRECT_RIGHTWARD,DIRECT_LEFTWARD: angle_vector(fAngle, ANGLEVECTOR_RIGHT, fAngle);
		case DIRECT_UPWARD,DIRECT_DOWNWARD: angle_vector(fAngle, ANGLEVECTOR_UP, fAngle);
	}
	
	if(item == DIRECT_BACKWARD || item == DIRECT_LEFTWARD || item == DIRECT_DOWNWARD)
	{
		fDistance *= -1;
	}
	
	xs_vec_mul_scalar(fAngle, fDistance, fAngle)
	xs_vec_add(fOrigin, fAngle, fOrigin)
	
	switch( item )
	{
		case DIRECT_FORWARD,DIRECT_BACKWARD,DIRECT_RIGHTWARD,DIRECT_LEFTWARD: fOrigin[2] = user_fOrigins[id][iItemid][2];
		case DIRECT_UPWARD,DIRECT_DOWNWARD: {
			fOrigin[1] = user_fOrigins[id][iItemid][1];
			fOrigin[0] = user_fOrigins[id][iItemid][0];
		}
	}
	
	new Float:fMaxs[3] = { 100.0, 100.0, 100.0 } , Float:fMins[3] = { -100.0, -100.0, -100.0 };
	
	switch( iItemid )
	{
		case OBJECT_ARENA:
		{
			for(new x = OBJECT_DUELER_1; x < sizeof user_fOrigins[]; x++)
			{
				switch( item )
				{
					case DIRECT_FORWARD,DIRECT_BACKWARD,DIRECT_RIGHTWARD,DIRECT_LEFTWARD: fAngle[2] = 0.0;
					case DIRECT_UPWARD,DIRECT_DOWNWARD: {
						fAngle[1] = 0.0;
						fAngle[0] = 0.0;
					}
				}
				
				if(xs_vec_len(user_fOrigins[id][x]) != 0.0) xs_vec_add(user_fOrigins[id][x], fAngle, user_fOrigins[id][x]);
			}
		}
		case OBJECT_DUELER_1,OBJECT_DUELER_2,OBJECT_ARENA_COUNTER:
		{
			new any:xArray[ARENA_DATA], any:xArray2[SIZE];
			ArrayGetArray(array_arena, temp_data[id], xArray)
			TrieGetArray(trie_arena_size, xArray[ARENA_NAME], xArray2, sizeof xArray2)
			
			xs_vec_copy(xArray2[MAXS], fMaxs);
			xs_vec_copy(xArray2[MINS], fMins);
			
			if(!((user_fOrigins[id][OBJECT_ARENA][0] + fMaxs[0]) >= fOrigin[0] &&
			        (user_fOrigins[id][OBJECT_ARENA][1] + fMaxs[1]) >= fOrigin[1] &&
				   (user_fOrigins[id][OBJECT_ARENA][0] + fMins[0]) <= fOrigin[0] &&
				      (user_fOrigins[id][OBJECT_ARENA][1] + fMins[1]) <= fOrigin[1]))
			{
				fOrigin = user_fOrigins[id][iItemid];
			}
		}
	}
	
	user_fOrigins[id][iItemid] = fOrigin;
	control_origin_menu(id, iItemid)
	return PLUGIN_HANDLED;
}

bool:is_object_stuck(const Float:vOrigin[3], const Float:fMaxs[3]={1.0,1.0,1.0}, const Float:fMins[3]={-1.0,-1.0,-1.0}, Float:fFixedOrigin[3]={0.0,0.0,0.0})
{
	new Float:fSizeMax[3]; fSizeMax = fMaxs;
	new Float:fSizeMin[3]; fSizeMin = fMins;
	
	new content;
	new Float:vPoint[3];
	
	//decrease the size values of the block
	fSizeMin[0] += 1.0;
	fSizeMax[0] -= 1.0;
	fSizeMin[1] += 1.0;
	fSizeMax[1] -= 1.0; 
	fSizeMin[2] += 1.0;
	fSizeMax[2] -= 1.0;
	
	//get the contents of the centre of all 6 faces of the block
	new i, bool:bStuck, fixes[14], maxfixes;
	for (i = 0; i < 14; i++)
	{
		//start by setting the point to the origin of the block (the middle)
		vPoint = vOrigin;
		
		//set the values depending on the loop number
		switch (i)
		{
			//corners
			case 0: { vPoint[0] += fSizeMax[0]; vPoint[1] += fSizeMax[1]; vPoint[2] += fSizeMax[2]; }
			case 1: { vPoint[0] += fSizeMin[0]; vPoint[1] += fSizeMax[1]; vPoint[2] += fSizeMax[2]; }
			case 2: { vPoint[0] += fSizeMax[0]; vPoint[1] += fSizeMin[1]; vPoint[2] += fSizeMax[2]; }
			case 3: { vPoint[0] += fSizeMin[0]; vPoint[1] += fSizeMin[1]; vPoint[2] += fSizeMax[2]; }
			case 4: { vPoint[0] += fSizeMax[0]; vPoint[1] += fSizeMax[1]; vPoint[2] += fSizeMin[2]; }
			case 5: { vPoint[0] += fSizeMin[0]; vPoint[1] += fSizeMax[1]; vPoint[2] += fSizeMin[2]; }
			case 6: { vPoint[0] += fSizeMax[0]; vPoint[1] += fSizeMin[1]; vPoint[2] += fSizeMin[2]; }
			case 7: { vPoint[0] += fSizeMin[0]; vPoint[1] += fSizeMin[1]; vPoint[2] += fSizeMin[2]; }
			
			//centre of faces
			case 8: { vPoint[0] += fSizeMax[0]; }
			case 9: { vPoint[0] += fSizeMin[0]; }
			case 10: { vPoint[1] += fSizeMax[1]; }
			case 11: { vPoint[1] += fSizeMin[1]; }
			case 12: { vPoint[2] += fSizeMax[2]; }
			case 13: { vPoint[2] += fSizeMin[2]; }
		}
		
		//get the contents of the point on the block
		content = engfunc(EngFunc_PointContents, vPoint)
		
		//if the point is out in the open
		if (content != CONTENTS_EMPTY)
		{
			//block is stuck
			bStuck = true;
			
			// apply fixes
			fixes[maxfixes] = i;
			maxfixes ++;
		}
	}
	
	//start by setting the point to the origin of the block (the middle)
	vPoint = vOrigin;
	
	if(bStuck)
	{
		for(new i; i < maxfixes; i++)
		{
			//fix the block.
			switch( fixes[i] )
			{
				//corners
				case 0: { vPoint[0] -= fSizeMax[0]; vPoint[1] -= fSizeMax[1]; vPoint[2] -= fSizeMax[2]; }
				case 1: { vPoint[0] -= fSizeMin[0]; vPoint[1] -= fSizeMax[1]; vPoint[2] -= fSizeMax[2]; }
				case 2: { vPoint[0] -= fSizeMax[0]; vPoint[1] -= fSizeMin[1]; vPoint[2] -= fSizeMax[2]; }
				case 3: { vPoint[0] -= fSizeMin[0]; vPoint[1] -= fSizeMin[1]; vPoint[2] -= fSizeMax[2]; }
				case 4: { vPoint[0] -= fSizeMax[0]; vPoint[1] -= fSizeMax[1]; vPoint[2] -= fSizeMin[2]; }
				case 5: { vPoint[0] -= fSizeMin[0]; vPoint[1] -= fSizeMax[1]; vPoint[2] -= fSizeMin[2]; }
				case 6: { vPoint[0] -= fSizeMax[0]; vPoint[1] -= fSizeMin[1]; vPoint[2] -= fSizeMin[2]; }
				case 7: { vPoint[0] -= fSizeMin[0]; vPoint[1] -= fSizeMin[1]; vPoint[2] -= fSizeMin[2]; }
				
				//centre of faces
				case 8: { vPoint[0] -= fSizeMax[0]; }
				case 9: { vPoint[0] -= fSizeMin[0]; }
				case 10: { vPoint[1] -= fSizeMax[1]; }
				case 11: { vPoint[1] -= fSizeMin[1]; }
				case 12: { vPoint[2] -= fSizeMax[2]; }
				case 13: { vPoint[2] -= fSizeMin[2]; }
			}
		}
	}
	// Setting the fixed vector/origin.
	fFixedOrigin = vPoint;
	
	//block stuck or not ? if so recheck.
	return bStuck;
}

public task_show_boxes(const taskid)
{
	static player, Float:fOrigin[3], Float:fMaxs[3], Float:fMins[3];
	player = taskid - TASK_SHOW_OBJECTS;
	
	fOrigin = user_fOrigins[player][OBJECT_ARENA];
	if(xs_vec_len(fOrigin) != 0.0)
	{
		static ent;
		//TrieGetCell(trie_arena_modelindex, xArray[ARENA_NAME], modelindex)
		
		if(!(ent = temp_arena_ent[player]))
		{
			static any:xArray[ARENA_DATA]; //, modelindex;
			ArrayGetArray(array_arena, temp_data[player], xArray)
			ent = temp_arena_ent[player] = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, "func_wall"));
			if(ent > 0)
			{
				engfunc(EngFunc_SetModel, ent, xArray[ARENA_RESOURCE])
				//engfunc(EngFunc_ModelIndex, ent, modelindex)
				
				set_pev(ent, pev_solid, SOLID_BSP)
				set_pev(ent, pev_movetype, MOVETYPE_NOCLIP)
				
				set_pev(ent, pev_rendermode, kRenderTransAdd)
				set_pev(ent, pev_renderamt, 150.0)
				
				dllfunc(DLLFunc_Spawn, ent)
			}
		}
		
		engfunc(EngFunc_SetOrigin, ent, fOrigin)
	}
	
	fOrigin = user_fOrigins[player][OBJECT_DUELER_1];
	if(xs_vec_len(fOrigin) != 0.0)
	{
		xs_vec_copy(player_size[1], fMaxs);
		xs_vec_copy(player_size[0], fMins);
		
		message_begin(MSG_ONE_UNRELIABLE, SVC_TEMPENTITY, _, player)
		write_byte(TE_BOX)
		engfunc(EngFunc_WriteCoord, (fOrigin[0] + fMins[0])) // mins
		engfunc(EngFunc_WriteCoord, (fOrigin[1] + fMins[1])) // mins
		engfunc(EngFunc_WriteCoord, (fOrigin[2] + fMins[2])) // mins
		engfunc(EngFunc_WriteCoord, (fOrigin[0] + fMaxs[0])) // maxs
		engfunc(EngFunc_WriteCoord, (fOrigin[1] + fMaxs[1])) // maxs
		engfunc(EngFunc_WriteCoord, (fOrigin[2] + fMaxs[2])) // maxs
		write_short(5)
		write_byte(255) // r
		write_byte(0) // g
		write_byte(0) // b
		message_end()
	}
	
	fOrigin = user_fOrigins[player][OBJECT_DUELER_2];
	if(xs_vec_len(fOrigin) != 0.0)
	{
		xs_vec_copy(player_size[1], fMaxs);
		xs_vec_copy(player_size[0], fMins);
		
		message_begin(MSG_ONE_UNRELIABLE, SVC_TEMPENTITY, _, player)
		write_byte(TE_BOX)
		engfunc(EngFunc_WriteCoord, (fOrigin[0] + fMins[0])) // mins
		engfunc(EngFunc_WriteCoord, (fOrigin[1] + fMins[1])) // mins
		engfunc(EngFunc_WriteCoord, (fOrigin[2] + fMins[2])) // mins
		engfunc(EngFunc_WriteCoord, (fOrigin[0] + fMaxs[0])) // maxs
		engfunc(EngFunc_WriteCoord, (fOrigin[1] + fMaxs[1])) // maxs
		engfunc(EngFunc_WriteCoord, (fOrigin[2] + fMaxs[2])) // maxs
		write_short(5)
		write_byte(0) // r
		write_byte(0) // g
		write_byte(255) // b
		message_end()
	}
	
	fOrigin = user_fOrigins[player][OBJECT_ARENA_COUNTER];
	if(xs_vec_len(fOrigin) != 0.0)
	{
		static ent;
		
		if(!(ent = temp_arena_counter_ent[player]))
		{
			ent = temp_arena_counter_ent[player] = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, "env_sprite"));
			if(ent > 0)
			{
				engfunc(EngFunc_SetModel, ent, arena_counter_spr[0])
				
				set_pev(ent, pev_solid, SOLID_NOT)
				set_pev(ent, pev_movetype, MOVETYPE_NOCLIP)
				
				set_pev(ent, pev_rendermode, kRenderTransAdd)
				set_pev(ent, pev_rendercolor, Float:{0.0,0.0,255.0})
				set_pev(ent, pev_renderamt, 255.0)
				
				dllfunc(DLLFunc_Spawn, ent)
			}
		}
		
		engfunc(EngFunc_SetOrigin, ent, fOrigin)
	}
	
	// check whether build/edit menus still open...
	new j, menu, oldmenu;
	for(j = 0; j < sizeof user_managing_menus[]; j++)
	{
		if(player_menu_info(player, oldmenu, menu))
		{
			if(menu == user_managing_menus[player][j] ||
				oldmenu == user_managing_menus[player][j])
			{
				oldmenu = -1;
				break;
			}
		}
		else { break; }
	}
	
	if(oldmenu != -1)
	{
		for(j = 0; j < sizeof user_managing_menus[]; j++) user_managing_menus[player][j] = 0;
		temp_data[player] = -1;
		if(temp_arena_ent[player] > 0)
		{
			engfunc(EngFunc_RemoveEntity, temp_arena_ent[player])
			temp_arena_ent[player] = 0;
		}
		if(temp_arena_counter_ent[player] > 0)
		{
			engfunc(EngFunc_RemoveEntity, temp_arena_counter_ent[player])
			temp_arena_counter_ent[player] = 0;
		}
		
		remove_task(taskid);
	}
}

stock StrTofVec(const szString[], Float:fVec[3])
{
	new szString2[66], sValue[22];
	copy(szString2, charsmax(szString2), szString)
	
	for(new i; i < 3; i++)
	{
		strbreak(szString2, sValue, charsmax(sValue), szString2, charsmax(szString2))
		remove_quotes(sValue)
		fVec[i] = floatstr(sValue);
	}
	return 1;
}

